#!/usr/bin/env python
"""
This file is part of the Hatkit Datafiddler, a tool for analyzing
MongoDB database content, particularly http traffic.
  
Copyright (C) 2011 Martin Holst Swende (hatkit@swende.se)

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
"""
import sys
'''
Created on Mar 8, 2010

@author: martin
'''
# We do some basic checking of required packages. 
importErrors = []
def check(package, name):
    try:
        __import__(package)
    except ImportError:
        importErrors.append((package,name))

check("PyQt4", "python-qt4 : Python bindings for Qt4")
#check("core.controllers.w3afException", "w3af (optional dependency)")
check("pymongo", "pymongo : Python drivers for MongoDB")

if len(importErrors)  > 0:
    print("Unfortunately, you have the following missing dependencies:")
    print("\n * ".join([name for (package,name) in importErrors]))
    #sys.exit(-1)
    
from PyQt4 import QtGui
from hatcore.prefecences import prefs
from ui import InitialisationWindow
from os.path import dirname
        
if __name__ == '__main__':
    
    app = QtGui.QApplication(sys.argv)
    #Load preferences
    prefs.load()
    prefs.setBasedir(dirname( __file__ ))
    InitialisationWindow.InitializationHandler()
    sys.exit(app.exec_())
    
