"""
This file is part of the Hatkit Datafiddler, a tool for analyzing
MongoDB database content, particularly http traffic.
  
Copyright (C) 2011 Martin Holst Swende (hatkit@swende.se)

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
"""
'''
Created on Mar 24, 2010

@author: martin
'''
from pymongo.connection import Connection
from pymongo.objectid import ObjectId
from pymongo.connection import Connection
class MongoConnector(object):
    '''
    classdocs
    '''


    def __init__(self, host="localhost", port=27017):
        '''
        Constructor
        '''
        self.host = host
        self.port = port
        
    def getDatabases(self):
        """Test the connectivity to the database and fetch info about 
        what 'sessions' are availble. This method checks all databases and their
        collections to see if the collection called 'conversations' is present, in which 
        case it is returned
        
        @return:  a tuple containing one list with names of the 'sessions, one 'displaylist' with size (no of documents)
        info included """
        self.connection = Connection(self.host, self.port)
        names = []
        displaynames =[]
        for dbName in self.connection.database_names():
            db = self.connection[dbName]
            for collectionName in db.collection_names():
                if "conversations" == collectionName:
                    size = db['conversations'].count()
                    names.append(dbName)
                    displaynames.append("%s (%s items)" % (dbName, size))
        return (names, displaynames)
    
    def useDatabase(self, dbname):
        self.db = self.connection[dbname]
        self.collection = self.db["conversations"]

        
if __name__ == '__main__':
    MongoConnector("localhost", 1717).test()
