"""
This file is part of the Hatkit Datafiddler, a tool for analyzing
MongoDB database content, particularly http traffic.
  
Copyright (C) 2011 Martin Holst Swende (hatkit@swende.se)

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
"""
from ui import WindowHandling
'''
Created on Feb 14, 2011

@author: martin
'''
from ui_generated import tabledata, about
from ui.MongoDBTableModel import QMongoTableModel
from PyQt4 import QtGui
from ui.TabledataSettings import TableviewSettingsWindow
from ui.WindowHandling import WindowUtils
from ui.ObjectInspection import ObjectInspectorHandler
from hatcore.prefecences import prefs

class TabledataMainwindow(tabledata.Ui_MainWindow):
    def __init__(self, connection):
        self.conn = connection
    
    def setupUi(self, MainWindow):
        self.mainwindow = MainWindow
        
        tabledata.Ui_MainWindow.setupUi(self, MainWindow)
        self.model = QMongoTableModel(self.conn,self.centralwidget )
        
        self.actionSettings.triggered.connect(self.showSettings)
        self.actionAbout.triggered.connect(self.showAbout)
        self.tableViewDB.doubleClicked.connect(self.showObjectInspector)

        self.tableViewDB.setModel(self.model)
        tv = self.tableViewDB
        # set column width to fit contents
        tv.resizeColumnsToContents()
        tv.resizeRowsToContents()
    
    def showAbout(self):
        WindowUtils.display(QtGui.QDialog(), about.Ui_Dialog())
    
    def showSettings(self):
        """Shows the edit-form for managing the aggregator setup"""
        window = QtGui.QDialog()
        ui = TableviewSettingsWindow(self.model, self.tableViewDB, prefs)
        WindowUtils.display(window, ui)
        
    def showObjectInspector(self):
        """
        Shows the object inspector
        """
        index = self.tableViewDB.currentIndex()
        mongoId = self.model.getItemId(index)
        object = self.model.loadItem(mongoId)
        ObjectInspectorHandler(object)
        