"""
This file is part of the Hatkit Datafiddler, a tool for analyzing
MongoDB database content, particularly http traffic.
  
Copyright (C) 2011 Martin Holst Swende (hatkit@swende.se)

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
"""
'''
Created on Feb 14, 2011

@author: martin
'''
from ui_generated import help , about
from PyQt4 import QtGui
class WindowUtils():
    windows = {}
    @staticmethod
    def display(window, ui):
        """ 
        This method displays and stores a window and a form. 
        
        Utility method to display a window containing a certain form. Due to some Qt -peculiarities, both of these
        variables must be kept in memory, otherwise it is gc:ed by Qt. If the window (widget/dialog etc) is gc:ed, 
        the window disappears. If the ui (Form object) is gc:ed, all signals and slots stop working. 
        This utility method keeps them both, and makes sure they are removed properly when the window is closed
        """
        ui.setupUi(window)
        window.show()
        WindowUtils.store(ui, window)
        
    @staticmethod
    def store(window,ui):
        """This method stpres a window and a form
         
        Due to some Qt -peculiarities, both of these
        variables must be kept in memory, otherwise it is gc:ed by Qt. If the window (widget/dialog etc) is gc:ed, 
        the window disappears. If the ui (Form object) is gc:ed, all signals and slots stop working. 
        This utility method keeps them both, and makes sure they are removed properly when the window is closed
        
        Actually, the above is not really true. Not only the form object must be stored, but any receiver of signals. So, 
        if you have connected the click of a button to a handler-class other than the form itself, that object which 
        receives the signals must be stored somewhere. See objectinspectorhandler for example. 
        """

        WindowUtils.windows[window] = ui
        #Reference to window need to be kept, otherwise window disappears
        #Refernce to ui-form need to be kept, otherwise signal/slots stop working
        def newClose(x):
            del WindowUtils.windows[window]
        window.closeEvent = newClose
        
        
    @staticmethod
    def alert(text=None, html=None):
        ui = help.Ui_HelpDialog()
        window = QtGui.QDialog()
        WindowUtils.display(window,ui)
        if text is not None : 
            print("-> "+text)
            ui.textBrowser_help.setText(text)
        elif html is not None:
            ui.textBrowser_help.setHtml(html)
        return ui
   
    @staticmethod
    def showHelp(html = None):
        WindowUtils.alert(html = html)
    
